/*
 * EXPLORADOR PULSAR
 * walgarcia@gmail.com
 * 20130225 :- we're not alone!
 *
 */

class ObjetoCeleste {
  String name ; //Nombre
  float c     ; //
  float d     ; //
  float dec   ; // Declination
  float ra    ; // Right Ascention
  float x,y,z ;
  float spectralIndex ;
  float size  ;
  

  // Constructor function
  ObjetoCeleste() {};
  
  //
  ObjetoCeleste(String _name, double _c, double _d, double _dec, double _ra){
    name = _name; //Nombre
    c    = new Float(_c)   ; //
    d    = new Float(_d)   ; //
    dec  = new Float(_dec) ; // Declination
    ra   = new Float(_ra)  ; // Right Ascention
    init();
  }

  // Load exoplanet data from a comma-delimited string (see key at top of class)
  void fromCSV(String[] sa) {
    name = sa[3];
    c    = float(sa[0]);
    d    = float(sa[1]);
    dec  = float(sa[2]);
    ra   = float(sa[4]);
  }

  void init(){
    float distance = d * 0.000326156;
    //if (distance >= 10000000) {
    //    star.position = new THREE.Vector3();
    //    continue;
    //}

    float phi = (ra + 90) * 15 * PI / 180;
    float theta = dec * PI / 180;
    float rho = distance;
    float rvect = rho * cos(theta);
    x = rvect * cos(phi);
    y = rvect * sin(phi);
    z = rho   * sin(theta);

    size = 20.0;
    if (c <= -1) c = 0;
    spectralIndex = c;
    //p.spectralLookup = map(star.c, -0.3, 1.52, 0, 1);

  }

  float getC(){
    return c;
  }
  float getD(){
    return d;
  }
  float getDec(){
    return dec;
  }
  float getRA(){
    return ra;
  }

  void update(){
  }
  void render(){
    pushMatrix();
    float x1    = ra * width / 24;
    float y1    = (dec + 90) * height / 180;
    colorMode(HSB);  
    int col = int(map(c, -0.3, 1.52, 255, 0));
    
    fill(col,255,255);
    stroke(col,255,255);
    translate(x1,y1);
    ellipse (0.0,0.0,tzoom ,tzoom);
    colorMode(RGB);
    popMatrix();
  }
}



